# -*- coding: utf-8 -*-  
from osgeo import gdal
import numpy as np
import matplotlib.pyplot as plt
import math
import pandas as pd
import time
import os
from sys import argv
from data_connect import DATAConncet

HydroID = [];
def main(slopfile_df, entropyfile_df, outpath):
    # df, df_entropy = pd.read_csv(slopfile, index_col = 0), pd.read_csv(entropyfile, index_col = 0);
    df= slopfile_df
    df_entropy = entropyfile_df

    df['entropy'] = df_entropy["entropy"].values;
    start = time.time()
    for i in range(0, df.shape[0]):
        line = df.iloc[i,:];
        if line.gully_slop > 8 and line.gully_slop < 50 and line.entropy < 0.2:
            while True:
                if line.HydroID not in HydroID:
                    HydroID.append(line.HydroID);         
                if line.NextDownID == -1:
                    break;
                else:
                    line = df[df.HydroID == line.NextDownID].iloc[0,:];
    HydroID.sort();
    dfres = df[df.HydroID.isin(HydroID)];
    print('cost: %.2f s\n' % (time.time()-start));
    dfres.to_csv(outpath,index=False);
    

                
if __name__ == '__main__':
    dataConnect = DATAConncet()

    # slopfile = "/data2/bcdt1/DamDetect/gully_slop.csv";
    # entropyfile = "/data2/bcdt1/DamDetect/geoentropy_res.csv"; 
    # outpath = "/data2/bcdt1_docker/siltdam/out/suscep_hdyro.csv";

    # slopfile=pd.read_csv("/data2/bcdt1_docker/siltdam/out/2019.csv")
    # entropyfile=pd.read_csv("/data2/bcdt1/DamDetect/geoentropy_res.csv")

    # main(slopfile, entropyfile, outpath);


    # # 获取上游传递数据
    slopfile = dataConnect.dataInputStream("gully_slop_port")
    entropyfile = dataConnect.dataInputStream("geoentropy_port")
    outpath = argv[1]

    #自动创建输出文件夹
    parentDir = os.path.dirname(outpath)
    isExists = os.path.exists(parentDir)
    if not isExists : os.makedirs(parentDir)

    main(slopfile, entropyfile, outpath);

    df = pd.read_csv(outpath)
    print(df)
    dataConnect.dataOutputStream(df,"suscep_hdyro_port")


    



